/* gmtProxy.h
   Generated by gSOAP 2.8.10 from gmt.h

Copyright(C) 2000-2012, Robert van Engelen, Genivia Inc. All Rights Reserved.
The generated code is released under one of the following licenses:
1) GPL or 2) Genivia's license for commercial use.
This program is released under the GPL with the additional exemption that
compiling, linking, and/or using OpenSSL is allowed.
*/

#ifndef gmtProxy_H
#define gmtProxy_H
#include "gmtH.h"

namespace gmt {

class SOAP_CMAC Proxy : public soap
{ public:
	/// Endpoint URL of service 'Proxy' (change as needed)
	const char *soap_endpoint;
	/// Constructor
	Proxy();
	/// Construct from another engine state
	Proxy(const struct soap&);
	/// Constructor with endpoint URL
	Proxy(const char *url);
	/// Constructor with engine input+output mode control
	Proxy(soap_mode iomode);
	/// Constructor with URL and input+output mode control
	Proxy(const char *url, soap_mode iomode);
	/// Constructor with engine input and output mode control
	Proxy(soap_mode imode, soap_mode omode);
	/// Destructor frees deserialized data
	virtual	~Proxy();
	/// Initializer used by constructors
	virtual	void Proxy_init(soap_mode imode, soap_mode omode);
	/// Delete all deserialized data (uses soap_destroy and soap_end)
	virtual	void destroy();
	/// Delete all deserialized data and reset to default
	virtual	void reset();
	/// Disables and removes SOAP Header from message
	virtual	void soap_noheader();
	/// Get SOAP Header structure (NULL when absent)
	virtual	const SOAP_ENV__Header *soap_header();
	/// Get SOAP Fault structure (NULL when absent)
	virtual	const SOAP_ENV__Fault *soap_fault();
	/// Close connection (normally automatic, except for send_X ops)
	virtual	int soap_close_socket();
	/// Force close connection (can kill a thread blocked on IO)
	virtual	int soap_force_close_socket();
	/// Print fault
	virtual	void soap_print_fault(FILE*);
#ifndef WITH_LEAN
	/// Print fault to stream
#ifndef WITH_COMPAT
	virtual	void soap_stream_fault(std::ostream&);
#endif

	/// Put fault into buffer
	virtual	char *soap_sprint_fault(char *buf, size_t len);
#endif

	/// Web service operation 'gmt' (returns error code or SOAP_OK)
	virtual	int gmt(time_t *_param_1) { return gmt(NULL, NULL, _param_1); }
	virtual	int gmt(const char *endpoint, const char *soap_action, time_t *_param_1);
};

} // namespace gmt

#endif
